HP_UpdateInterval = .1 -- update frequency == 1/HP_UpdateDelay

local AppName, HaloPro= ...
local OptionsAppName = AppName .. "_Options"
local VERSION = AppName .. "-v0.1.0"


local rc = LibStub("LibRangeCheck-2.0")
local LSM = LibStub:GetLibrary("LibSharedMedia-3.0", true)
local LibDualSpec = LibStub("LibDualSpec-1.0", true)
local L = LibStub("AceLocale-3.0"):GetLocale(AppName)

function HaloPro_OnLoad(self) 
		
	-- Global variables called OnLoad
	HP_FadeIN = 0.85
	HP_FadeOUT = 0
	FO_Time = 0
	FI_Time = 0
	pulseflag = 0
	tcount = 0
	cdFlag = 0
	oneTimeC = 0
	fadeouttimer = 1.5
	options_open_Flag = 0
	playonce = 1
	
	-- Setup default values
	default_width = 350
	default_height = 10
	default_fadeintimer = 4
	default_off_cd_warning = 1
	default_Lock_Flag = 0
	default_OffCD_Flag = 1
	default_tcount_time1 = 1
	default_flash_num = 3
	default_max_alpha_adjust = 0.85
	default_HP_Sound_Flag = 1
	default_HP_Sound = "MapPing"
	default_Theme_select_Spec1 = "Shadow"
	default_Theme_Index_Spec1 = 1
	default_Theme_select_Spec2 = "Holy"
	default_Theme_Index_Spec2 = 2
	default_HP_Tracking = 'target'
	SpellToMonitor = "Halo"  -- set to "Mind Blast" if testing is needed without Halo present
	
	Halo_Check()
	First_Time_init()
	Theme_select_Spec_store()
	
	-- Creates config messages
	HP_Unlocked_Msg = CreateFrame('frame', 'HP_Unlocked_Msg', UIParent)
	HP_Unlocked_Msg:SetAllPoints()
	HP_Unlocked_Msg = HP_Unlocked_Msg:CreateFontString(nil, 'OVERLAY')
	HP_Unlocked_Msg:SetFont(STANDARD_TEXT_FONT, 32, "OUTLINE")
	HP_Unlocked_Msg:SetText('|cff00ddaa--(please target something you can attack or heal)--|n|nwhile hovering over the HaloPro graphic|n|nmousewheel to adjust width|nshift + mousewheel to adjust height|nleft click and drag with mouse to re-position|n|nHaloPro is currently unlocked|n/HP lock when adjustments are complete|r')
	HP_Unlocked_Msg:SetPoint('CENTER',0,200)
	HP_Unlocked_Msg:Hide()
	
	-- Creates the main bar
	f = CreateFrame("Frame","HaloPro_MainFrame",UIParent)
	f:SetMovable(true)
	f:SetResizable(true)
	f:SetClampedToScreen(true)
	f:EnableMouse(true)
	f:EnableKeyboard(true)
	f:EnableMouseWheel(true)
	f:SetUserPlaced(true)
	f:RegisterForDrag("LeftButton")
	f:SetScript("OnDragStart", f.StartMoving)
	f:SetScript('OnDragStop', function(self)	
		f:StopMovingOrSizing()
		point, relativeTo, relativePoint, xOfs, yOfs = f:GetPoint()
		xOfs = (floor(xOfs))
		yOfs = (floor(yOfs))
		if options_open_Flag == 1 then
			Set_HP_X_Pos:SetText(xOfs)
			Set_HP_Y_Pos:SetText(yOfs)
		end
		HP_Set_Position()
	end)
	f:SetFrameStrata("BACKGROUND")
	UIParent:SetScript('OnUpdate', MyAddon_OnUpdate)
	UIParent.TimeSinceLastUpdate = 0 
	
	f:SetScript('OnMouseWheel', function(self, delta)
		if IsShiftKeyDown() then
			if delta == 1 then
				HP_height = HP_height + 1
				print("Increasing HaloPro height to " .. HP_height)
			elseif delta == -1 then
				HP_height = HP_height - 1
				print("Decreasing HaloPro height to " .. HP_height)
			end
			HP_Resize_height()
		else
			if delta == 1 then
				HP_width = HP_width + 10
				print("Increasing HaloPro width to " .. HP_width)
			elseif delta == -1 then
				HP_width = HP_width - 10
				print("Decreasing HaloPro width to " .. HP_width)
			end
			HP_Resize_width()
		end
	end)	
	f:SetWidth(HP_width) 	-- Set these to whatever height/width is needed 
	f:SetHeight(HP_height) 	-- for your Texture

	t = f:CreateTexture(HP_center,"BACKGROUND")
	t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec1.."\\center.tga")
	t:SetAllPoints(f)
	f.texture = t
	f:SetPoint("CENTER",0,0)
	if HaloCheck_Flag == 1 then
		f:Show()
	elseif HaloCheck_Flag == 0 then
		f:Hide()
	end
	f:SetScript('OnShow', function(self)
		HP_Lock()
	end)
		
	print("HaloPro has initialized")
			
end
function MyAddon_OnUpdate(UIParent, elapsed)
	local self = UIParent
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed 	
	Halo_Check()
	Theme_select_Spec_store()
	local Chosen_Theme = 0
	if HP_currentSpec == 1 then
		Chosen_Theme = Theme_select_Spec1
	elseif HP_currentSpec == 2 then
		Chosen_Theme = Theme_select_Spec2
	else
		Chosen_Theme = default_Theme_select_Spec1
	end
	if HaloCheck_Flag == 1 then
		if options_open_Flag == 1 then
			f:Show()
			HP_Unlocked_Msg:Hide()
		end
		rc.RegisterCallback(self, rc.CHECKERS_CHANGED, function() --[[print("need to refresh my stored checkers")]] end)
		local minRange, maxRange = rc:GetRange(HP_Tracking)
		if UnitCanAttack('player', HP_Tracking) or UnitCanAssist('player', HP_Tracking) then
			DoubleCheckMaxFriend = IsSpellInRange("Fear Ward", HP_Tracking)
			DoubleCheckMaxEnemy = IsSpellInRange("Shoot", HP_Tracking)
			if UnitName(HP_Tracking) == UnitName('player') then
				if Lock_Flag == 1 then
					HP_Unlocked_Msg:Hide()
				end
			else
				if not minRange then --nothing targetted
					if options_open_Flag == 1 then	
						t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\center.tga")
						f:Show()
						HP_Unlocked_Msg:Hide()
					else
						f:Hide()
						if Lock_Flag == 1 then
							HP_Unlocked_Msg:Hide()
						end
						playonce = 1
					end
				elseif not maxRange then --nothing targetted
					if options_open_Flag == 1 then	
						t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\center.tga")
						f:Show()
						HP_Unlocked_Msg:Hide()
					else
						f:Hide()
						if Lock_Flag == 1 then
							HP_Unlocked_Msg:Hide()
						end
						playonce = 1
					end		
				elseif maxRange <= 20 then
					f:Show()
					if tcount_time1 == 1 then
						if (tcount <= tcount_time1) then
							if OffCD_Flag == 1 then
								f:SetAlpha(1)
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
							end
						else
							if pulseflag == 0 then
								f:SetAlpha(max_alpha_adjust - 0.25)
							end
							playonce = 1
							t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\left.tga")
						end
						if tcount == (tcount_time1 + tcount_time1) then
							tcount_counter = tcount_counter + 1
							if tcount_counter < flash_num then
								tcount = 0
							end
						end
					elseif tcount_time1 > 1 then
						if (tcount < tcount_time1) then
							if OffCD_Flag == 1 then
								f:SetAlpha(1)
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
							end
						else
							if pulseflag == 0 then
								f:SetAlpha(max_alpha_adjust - 0.25)
							end
							playonce = 1
							t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\left.tga")
						end
						if tcount == (tcount_time1 + tcount_time1) then
							tcount_counter = tcount_counter + 1
							if tcount_counter < flash_num then
								tcount = 0
							end
						end
					end
				elseif minRange >= 20 and maxRange <= 25 then
					f:Show()
					if tcount_time1 == 1 then
						if (tcount <= tcount_time1) then
							if OffCD_Flag == 1 then
								f:SetAlpha(1)
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
							end
						else
							if pulseflag == 0 then
								f:SetAlpha(max_alpha_adjust - 0.15)
							end
							playonce = 1
							t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\mid_left.tga")
						end
						if tcount == (tcount_time1 + tcount_time1) then
							tcount_counter = tcount_counter + 1
							if tcount_counter < flash_num then
								tcount = 0
							end
						end
					elseif tcount_time1 > 1 then
						if (tcount < tcount_time1) then
							if OffCD_Flag == 1 then
								f:SetAlpha(1)
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
							end
						else
							if pulseflag == 0 then
								f:SetAlpha(max_alpha_adjust - 0.15)
							end
							playonce = 1
							t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\mid_left.tga")
						end
						if tcount == (tcount_time1 + tcount_time1) then
							tcount_counter = tcount_counter + 1
							if tcount_counter < flash_num then
								tcount = 0
							end
						end
					end
				elseif minRange >= 25 and maxRange <= 30 then
					f:Show()
					if tcount_time1 == 1 then
						if (tcount <= tcount_time1) then
							if OffCD_Flag == 1 then
								f:SetAlpha(1)
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
							end
						else
							if pulseflag == 0 then
								f:SetAlpha(max_alpha_adjust)
							end
							if playonce == 1 then
								if HP_Sound_Flag == 1 then
									PlaySound(HP_Sound,"master")
								end
								playonce = 0
							end
							if DoubleCheckMaxFriend == 1 or DoubleCheckMaxEnemy == 1 then
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\center.tga")
							else
								if pulseflag == 0 then
									f:SetAlpha(max_alpha_adjust - 0.15)
								end
								playonce = 1
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\mid_right.tga")
							end
						end
					elseif tcount_time1 > 1 then
						if (tcount < tcount_time1) then
							if OffCD_Flag == 1 then
								f:SetAlpha(1)
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
							end
						else
							if pulseflag == 0 then
								f:SetAlpha(max_alpha_adjust)
							end
							if playonce == 1 then
								if HP_Sound_Flag == 1 then
									if cdFlag == 0 then
										PlaySound(HP_Sound,"master")
									end
								end
								playonce = 0
							end
							if DoubleCheckMaxFriend == 1 or DoubleCheckMaxEnemy == 1 then
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\center.tga")
							else
								if pulseflag == 0 then
									f:SetAlpha(max_alpha_adjust - 0.15)
								end
								playonce = 1
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\mid_right.tga")
							end
						end
					end
					if tcount == (tcount_time1 + tcount_time1) then
						tcount_counter = tcount_counter + 1
						if tcount_counter < flash_num then
							tcount = 0
						end
					end
				elseif minRange >= 30 and maxRange <=35 then
					f:Show()
					if tcount_time1 == 1 then
						if (tcount <= tcount_time1) then
							if OffCD_Flag == 1 then
								f:SetAlpha(1)
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
							end
						else
							if pulseflag == 0 then
								f:SetAlpha(max_alpha_adjust - 0.15)
							end
							playonce = 1
							t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\mid_right.tga")
						end
					elseif tcount_time1 > 1 then
						if (tcount < tcount_time1) then
							if OffCD_Flag == 1 then
								f:SetAlpha(1)
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
							end
						else
							if pulseflag == 0 then
								f:SetAlpha(max_alpha_adjust - 0.15)
							end
							playonce = 1
							t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\mid_right.tga")
						end
					end
					if tcount == (tcount_time1 + tcount_time1) then
						tcount_counter = tcount_counter + 1
						if tcount_counter < flash_num then
							tcount = 0
						end
					end
				elseif minRange >= 35 then
					f:Show()
					if tcount_time1 == 1 then
						if (tcount <= tcount_time1) then
							if OffCD_Flag == 1 then
								f:SetAlpha(1)
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
							end
						else
							if pulseflag == 0 then
								f:SetAlpha(max_alpha_adjust - 0.25)
							end
							playonce = 1
							t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\right.tga")
						end
					elseif tcount_time1 > 1 then
						if (tcount < tcount_time1) then
							if OffCD_Flag == 1 then
								f:SetAlpha(1)
								t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
							end
						else
							if pulseflag == 0 then
								f:SetAlpha(max_alpha_adjust - 0.25)
							end
							playonce = 1
							t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\right.tga")
						end
					end
					if tcount == (tcount_time1 + tcount_time1) then
						tcount_counter = tcount_counter + 1
						if tcount_counter < flash_num then
							tcount = 0
						end
					end
				end
			end
		else
			f:Hide()
			if Lock_Flag == 1 then
				HP_Unlocked_Msg:Hide()
			end
			if options_open_Flag == 1 then
				f:Show()
				HP_Unlocked_Msg:Hide()
			end
		end

		while (self.TimeSinceLastUpdate > HP_UpdateInterval) do
				
			local start, duration, enabled = GetSpellCooldown(SpellToMonitor)
			local framerate = GetFramerate()
			local spellcd = GetTime()
			FO_Time = fadeouttimer/framerate
			tcount = tcount + 1
			if tcount >= 5000 then
				tcount = 1000
			end
			if ( start > 0 and duration > 1.5) then
				spellcd = spellcd - start
				spellcd = duration - spellcd 
				if fadeintimer == nil then
					fadeintimer = default_fadeintimer
				end
				if spellcd <= fadeintimer then
					duration = fadeintimer
					spellcd = spellcd / duration
					FI_Time = max_alpha_adjust - spellcd
					HP_FadeIN = FI_Time
				end
				if cdFlag == 0 then
					pulseflag = 1
					cdFlag = 1
					HP_FadeIN = 0
				end
				f:SetAlpha(HP_FadeIN)
			else
				HP_FadeIN = max_alpha_adjust
				cdFlag = 0
				if pulseflag == 1 then
					f:Show()
					if OffCD_Flag == 1 then
						f:SetAlpha(1)
						t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Chosen_Theme.."\\offcd.tga")
						f:SetAlpha(max_alpha_adjust)
					end
					tcount_counter = 0
					tcount = 0
					pulseflag = 0
				end
			end
			self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - HP_UpdateInterval;
		end
	elseif HaloCheck_Flag == 0 then
		f:Hide()
		HP_Unlocked_Msg:Hide()
	end
end

function First_Time_init()
	if max_alpha_adjust == nil then
		max_alpha_adjust = default_max_alpha_adjust
	end
	if OffCD_Flag == nil then
		OffCD_Flag = default_off_cd_warning
	end
	if fadeintimer == nil then
		fadeintimer = default_fadeintimer
	end
	if HP_width == nil then
		HP_width = default_width
	end
	if HP_height == nil then
		HP_height = default_height
	end
	if tcount_time1 == nil then
		tcount_time1 = default_tcount_time1 
	end
	if flash_num == nil then
		flash_num = default_flash_num
	end
	if Theme_select_Spec1 == nil then
		Theme_select_Spec1 = default_Theme_select_Spec1
	end
	if Theme_Index_Spec1 == nil then
		Theme_Index_Spec1 = default_Theme_Index_Spec1
	end
	if Theme_select_Spec2 == nil then
		Theme_select_Spec2 = default_Theme_select_Spec2
	end
	if Theme_Index_Spec2 == nil then
		Theme_Index_Spec2 = default_Theme_Index_Spec2
	end
	if HP_Sound == nil then
		HP_Sound = default_HP_Sound 
	end
	if HP_Sound_Flag == nil then
		HP_Sound_Flag = default_HP_Sound_flag
	end
	if HP_Tracking == nil then
		HP_Tracking = default_HP_Tracking
	end
end

function Theme_select_Spec_store()

	HP_currentSpec = GetActiveSpecGroup()
	if HP_currentSpec == 1 then
		HP_activeSpec = "your Primary spec"
	elseif HP_currentSpec == 2 then
		HP_activeSpec = "your Secondary spec"
	else
		HP_activeSpec = "no spec: Under level 15?"
	end
	
	HP_currentSpecial = GetSpecialization()
	if HP_currentSpecial == 1 then
		HP_activeSpecial = "Discipline is your current specialization"
		if HP_currentSpec == 1 then
			default_Theme_Index_Spec1 = 3
		elseif HP_currentSpec == 2 then
			default_Theme_Index_Spec2 = 3
		end
	elseif HP_currentSpecial == 2 then
		HP_activeSpecial = "Holy is your current specialization"
		if HP_currentSpec == 1 then
			default_Theme_Index_Spec1 = 2
		elseif HP_currentSpec == 2 then
			default_Theme_Index_Spec2 = 2
		end
	elseif HP_currentSpecial == 3 then
		HP_activeSpecial = "Shadow is your current specialization"
		if HP_currentSpec == 1 then
			default_Theme_Index_Spec1 = 1
		elseif HP_currentSpec == 2 then
			default_Theme_Index_Spec2 = 1
		end
	end
	
	if Theme_Index_Spec1 == 1 then
		Theme_select_Spec1 = "Shadow"
	elseif Theme_Index_Spec1 == 2 then
		Theme_select_Spec1 = "Holy"
	elseif Theme_Index_Spec1 == 3 then
		Theme_select_Spec1 = "Disc"
	elseif Theme_Index_Spec1 == 4 then
		Theme_select_Spec1 = "Button"
	elseif Theme_Index_Spec1 == 5 then
		Theme_select_Spec1 = "Custom"
	else
		Theme_select_Spec1 = default_Theme_select_Spec1
	end
	
	if Theme_Index_Spec2 == 1 then
		Theme_select_Spec2 = "Shadow"
	elseif Theme_Index_Spec2 == 2 then
		Theme_select_Spec2 = "Holy"
	elseif Theme_Index_Spec2 == 3 then
		Theme_select_Spec2 = "Disc"
	elseif Theme_Index_Spec2 == 4 then
		Theme_select_Spec2 = "Button"
	elseif Theme_Index_Spec2 == 5 then
		Theme_select_Spec2 = "Custom"
	else
		Theme_select_Spec2 = default_Theme_select_Spec2
	end
end

function HPSound()

	-- Create the HPSound_dropDown, and configure its appearance
	HPSound_dropDown = CreateFrame("FRAME", "HPSoundDropDown", HP_Options_Sub_Panel, "UIDropDownMenuTemplate")
	HPSound_dropDown:SetPoint("Center",-140, 75)
	UIDropDownMenu_SetWidth(HPSound_dropDown, 125)
	UIDropDownMenu_SetText(HPSound_dropDown,HP_Sound)
	
	-- Create and bind the initialization function to the HPSound_dropDown menu
	UIDropDownMenu_Initialize(HPSound_dropDown, function(self, level, menuList)
		local info = UIDropDownMenu_CreateInfo()
		info.func = self.SetValue
		if (level or 1) == 1 then
			for i=0,10 do
				if i == 0 then
					info.text, info.arg1 = "Human Exploration", i
				elseif i == 1 then
					info.text, info.arg1 = "PVP Enter Queue", i
				elseif i == 2 then
					info.text, info.arg1 = "Main Menu Open", i
				elseif i == 3 then
					info.text, info.arg1 = "Item Weapon Sound", i
				elseif i == 4 then
					info.text, info.arg1 = "Quest Added", i
				elseif i == 5 then
					info.text, info.arg1 = "Quest Completed", i
				elseif i == 6 then
					info.text, info.arg1 = "Mini Map Open", i
				elseif i == 7 then
					info.text, info.arg1 = "Talent Screen Open", i
				elseif i == 8 then
					info.text, info.arg1 = "Map Ping", i
				elseif i == 9 then
					info.text, info.arg1 = "Generic Sound", i
				elseif i == 10 then
					info.text, info.arg1 = "Deathbind Sound", i
				end
				UIDropDownMenu_AddButton(info)
			end
		else
			-- Display a nested group 
		end
	end)

-- Implement the function to change the Sound
	function HPSound_dropDown:SetValue(newValue)
		if newValue == 0 then
			HP_Sound = "HumanExploration"
		elseif newValue == 1 then
			HP_Sound = "PVPENTERQUEUE"
		elseif newValue == 2 then
			HP_Sound = "igMainMenuOpen"
		elseif newValue == 3 then
			HP_Sound = "ITEMWEAPONSOUND"
		elseif newValue == 4 then
			HP_Sound = "QUESTADDED"
		elseif newValue == 5 then
			HP_Sound = "QUESTCOMPLETED"
		elseif newValue == 6 then
			HP_Sound = "igMiniMapOpen"
		elseif newValue == 7 then
			HP_Sound = "TalentScreenOpen"
		elseif newValue == 8 then
			HP_Sound = "MapPing"
		elseif newValue == 9 then
			HP_Sound = "ITEMGENERICSOUND"
		elseif newValue == 10 then
			HP_Sound = "Deathbind Sound"
		end
		
		
		-- Update the text; if we merely wanted it to display newValue, we would not need to do this
		UIDropDownMenu_SetText(HPSound_dropDown, HP_Sound)
		
		-- Because this is called from a sub-menu, only that menu level is closed by default.
		-- Close the entire menu with this next call
		CloseDropDownMenus()
		PlaySound(HP_Sound,"master")
		
	end
end

function XY_Relative_Pos()
	point, relativeTo, relativePoint, xOfs, yOfs = f:GetPoint()
	Relative_Point = point -- user-configurable setting

	-- Create the XY_REL_dropDown, and configure its appearance
	XY_REL_dropDown = CreateFrame("FRAME", "XY_RelDropDown", HP_Options_Sub_Panel, "UIDropDownMenuTemplate")
	XY_REL_dropDown:SetPoint("Center",-370, -80)
	UIDropDownMenu_SetWidth(XY_REL_dropDown, 100)
	UIDropDownMenu_SetText(XY_REL_dropDown,Relative_Point)
	-- Create and bind the initialization function to the XY_REL_dropDown menu
	UIDropDownMenu_Initialize(XY_REL_dropDown, function(self, level, menuList)
		local info = UIDropDownMenu_CreateInfo()
		info.func = self.SetValue
		if (level or 1) == 1 then
			for i=0,8 do
				if i == 0 then
					info.text, info.arg1 = "TOPLEFT", i
				elseif i == 1 then
					info.text, info.arg1 = "TOP", i
				elseif i == 2 then
					info.text, info.arg1 = "TOPRIGHT", i
				elseif i == 3 then
					info.text, info.arg1 = "LEFT", i
				elseif i == 4 then
					info.text, info.arg1 = "CENTER", i
				elseif i == 5 then
					info.text, info.arg1 = "RIGHT", i
				elseif i == 6 then
					info.text, info.arg1 = "BOTTOMLEFT", i
				elseif i == 7 then
					info.text, info.arg1 = "BOTTOM", i
				elseif i == 8 then
					info.text, info.arg1 = "BOTTOMRIGHT", i
				end
				UIDropDownMenu_AddButton(info)
			end
		else
		-- Display a nested group 
		end
end)

-- Implement the function to change the Relative_Point
function XY_REL_dropDown:SetValue(newValue)
	if newValue == 0 then
		Relative_Point = "TOPLEFT"
	elseif newValue == 1 then
		Relative_Point= "TOP"
	elseif newValue == 2 then
		Relative_Point = "TOPRIGHT"
	elseif newValue == 3 then
		Relative_Point = "LEFT"
	elseif newValue == 4 then
		Relative_Point = "CENTER"
	elseif newValue == 5 then
		Relative_Point = "RIGHT"
	elseif newValue == 6 then
		Relative_Point = "BOTTOMLEFT"
	elseif newValue == 7 then
		Relative_Point = "BOTTOM"
	elseif newValue == 8 then
		Relative_Point = "BOTTOMRIGHT"
	end
	
	-- Update the text; if we merely wanted it to display newValue, we would not need to do this
	UIDropDownMenu_SetText(XY_REL_dropDown, Relative_Point)
	point = Relative_Point
	-- Because this is called from a sub-menu, only that menu level is closed by default.
	-- Close the entire menu with this next call
	CloseDropDownMenus()
	HP_Set_Position()
end
end

function HaloPro_Panel_OnLoad(panel)
	panel.name = "HaloPro " .. GetAddOnMetadata("HaloPro", "Version"); -- Set the name for the Category for the Panel
	HP_Panel_Name_Store = panel.name
		
    panel.okay = function (self)      -- When the player clicks okay, run this function.
		if HaloCheck_Flag == 0 then
			f:Hide()
		end
		options_open_Flag = 0
		HP_Lock()
	end;

    panel.cancel = function (self)        -- When the player clicks cancel, run this function.
		if HaloCheck_Flag == 0 then
			f:Hide()
		end
		options_open_Flag = 0
		HP_Lock()
	end;
	
	panel.default = function (self)
		Default_HP_Settings()
	end;
	
	panel.refresh = function (self)
		
		if HaloCheck_Flag == 0 then
			Lock_Flag = 1
			Lock_checkButton:Hide()
			No_Halo_Msg:Show()
		else
			Lock_checkButton:Show()
			No_Halo_Msg:Hide()
		end
		if Lock_Flag == 0 then
			options_open_Flag = 1
			if HaloCheck_Flag == 1 then
				options_open_Flag = 1
				f:Show()
			end
			Lock_checkButton:SetChecked(false)
			Lock_checkButton.text:SetText("HaloPro is Unlocked - Check to lock")
			FadeINSlider:SetValue(fadeintimer)
			MaxASlider:SetValue(max_alpha_adjust)
			FlashNumSlider:SetValue(flash_num)
			FlashSpeedSlider:SetValue(tcount_time1)
			Set_HP_Height:Show()
			Set_HP_Width:Show()
			Set_HP_X_Pos:Show()
			Set_HP_Y_Pos:Show()
			point, relativeTo, relativePoint, xOfs, yOfs = f:GetPoint()
			xOfs = (floor(xOfs))
			Set_HP_X_Pos:SetText(xOfs)
			yOfs = (floor(yOfs))
			Set_HP_Y_Pos:SetText(yOfs)
			Relative_Point = point -- user-configurable setting
			UIDropDownMenu_SetText(HPSound_dropDown,HP_Sound)
			UIDropDownMenu_SetText(XY_REL_dropDown,Relative_Point)
			HP_Sub_Panel_Refresh(HP_Options_Sub_Panel)
			HP_Sound_Refresh(HP_Options_Sub_Panel)
			UnLocked_HP_Panel(panel)
			HP_Lock()
			if HP_Tracking == 'focus' then
				HP_Track_Toggle:LockHighlight()
				HP_Track_Toggle:SetText("Track: "..HP_Tracking)
			elseif HP_Tracking == 'target' then
				HP_Track_Toggle:UnlockHighlight()
				HP_Track_Toggle:SetText("Track: "..HP_Tracking)
			end
			if options_open_Flag == 1 then
				f:Show()
				HP_Unlocked_Msg:Hide()
			end
		elseif Lock_Flag == 1 then
			Lock_checkButton:SetChecked(true)
			Lock_checkButton.text:SetText("HaloPro is Locked")
			FadeINSlider:SetValue(fadeintimer)
			MaxASlider:SetValue(max_alpha_adjust)
			FlashNumSlider:SetValue(flash_num)
			FlashSpeedSlider:SetValue(tcount_time1)
			Set_HP_Height:Show()
			Set_HP_Width:Show()
			Set_HP_X_Pos:Show()
			Set_HP_Y_Pos:Show()
			point, relativeTo, relativePoint, xOfs, yOfs = f:GetPoint()
			xOfs = (floor(xOfs))
			Set_HP_X_Pos:SetText(xOfs)
			yOfs = (floor(yOfs))
			Set_HP_Y_Pos:SetText(yOfs)
			Relative_Point = point -- user-configurable setting
			UIDropDownMenu_SetText(HPSound_dropDown,HP_Sound)
			UIDropDownMenu_SetText(XY_REL_dropDown,Relative_Point)
			HP_Sub_Panel_Refresh(HP_Options_Sub_Panel)
			HP_Sound_Refresh(HP_Options_Sub_Panel)
			UnLocked_HP_Panel(panel)
			HP_Lock()
			if HP_Tracking == 'focus' then
				HP_Track_Toggle:LockHighlight()
				HP_Track_Toggle:SetText("Track: "..HP_Tracking)
			elseif HP_Tracking == 'target' then
				HP_Track_Toggle:UnlockHighlight()
				HP_Track_Toggle:SetText("Track: "..HP_Tracking)
			end
			if options_open_Flag == 1 then
				f:Show()
				HP_Unlocked_Msg:Hide()
			end
		end
	end
	
 -- Register in the Interface Addon Options GUI
 -- Set the name for the Category for the Options Panel
 -- Add the panel to the Interface Options
	
	InterfaceOptions_AddCategory(panel);  -- Add the panel to the Interface Options
	
	HaloPro_CreateOptionsPanel(panel)
end
function HP_Set_Position()
	f:ClearAllPoints()
	Rel_Set_Point = ""..point..""
	f:SetPoint(Rel_Set_Point,xOfs,yOfs)
	HP_Sub_Panel_Refresh(HP_Options_Sub_Panel)
end
function HP_Resize_height()
	f:SetHeight(HP_height) -- for your Texture
	HP_Sub_Panel_Refresh(HP_Options_Sub_Panel)
end
function HP_Resize_width()
	f:SetWidth(HP_width) -- for your Texture
	HP_Sub_Panel_Refresh(HP_Options_Sub_Panel)
end
function HP_Sub_Panel_Refresh(HP_Options_Sub_Panel)
	Set_HP_Height:SetNumber(HP_height)
	HeightSlider:SetValue(HP_height)
	Set_HP_Width:SetNumber(HP_width)
	WidthSlider:SetValue(HP_width)
	XposSlider:SetValue(xOfs)
	Set_HP_X_Pos:SetText(xOfs)
	YposSlider:SetValue(yOfs)
	Set_HP_Y_Pos:SetText(yOfs)
end
function HP_Sound_Refresh(HP_Options_Sub_Panel)
	if HP_Sound_Flag == nil then
		HP_Sound_Flag = default_HP_Sound_Flag
	end
	if HP_Sound_Flag == 0  then
		Sound_checkButton:SetChecked(false)
		Sound_checkButton.text:SetText("Sound warning is disabled - Check to enable sound warning")
		HPSound_dropDown:Hide()
	elseif HP_Sound_Flag == 1 then
		Sound_checkButton:SetChecked(true)
		Sound_checkButton.text:SetText("WILL play sound warning |n  when in proper Halo range")
		HPSound_dropDown:Show()
	end
	
	-- OnClick Handler for Sound
	Sound_checkButton:SetScript("OnClick", function(self)
		isSound_checkButton = self:GetChecked();
		if isSound_checkButton == nill then
			HP_Sound_Flag = 0
			Sound_checkButton:SetChecked(false)
			Sound_checkButton.text:SetText("Sound warning is disabled - Check to enable sound warning")
			HPSound_dropDown:Hide()
		else
			HP_Sound_Flag = 1
			Sound_checkButton:SetChecked(true)
			Sound_checkButton.text:SetText("WILL play sound warning |n  when in proper Halo range")
			HPSound_dropDown:Show()
		end
	end)
end

function HaloPro_CreateOptionsPanel(panel)
	HP_Options = {};
	HP_Options.panel = CreateFrame( "Frame","HP_Options_Panel",panel)
	
	-- Make a child panel to hold the theme options
	HP_Options_Theme = CreateFrame( "Frame", "HP_Options_Theme", panel);
	HP_Options_Theme.name = "Theme";
	HP_Options_Theme.parent = HP_Panel_Name_Store; -- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
 	InterfaceOptions_AddCategory(HP_Options_Theme); -- Add the child to the Interface Options
		
	HP_Options_Theme.okay = function (self)      -- When the player clicks okay, run this function.
		if HaloCheck_Flag == 0 then
			f:Hide()
		end
		options_open_Flag = 0
		HP_Lock()
	end;

    HP_Options_Theme.cancel = function (self)        -- When the player clicks cancel, run this function.
		if HaloCheck_Flag == 0 then
			f:Hide()
		end
		options_open_Flag = 0
		HP_Lock()
	end;
	
	HP_Options_Theme.default = function (self)
		Default_HP_Settings()
	end;
	
	HP_Options_Theme.refresh = function (self)
		Theme_select_Spec_store()
		Spec1_T_Slider:SetValue(Theme_Index_Spec1)
		Spec1_t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec1.."\\center.tga")
		Spec2_T_Slider:SetValue(Theme_Index_Spec2)
		Spec2_t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec2.."\\center.tga")
		Current_Talents_Msg:SetText('Currently, you are using '..HP_activeSpec)
		Current_Special_Msg:SetText(HP_activeSpecial)
	end
			
	-- Create No Halo messages
	No_Halo_Msg = CreateFrame('frame', 'No_Halo_Msg', panel)
	No_Halo_Msg:SetAllPoints()
	No_Halo_Msg = No_Halo_Msg:CreateFontString(nil, 'OVERLAY')
	No_Halo_Msg:SetFont(STANDARD_TEXT_FONT, 28, "OUTLINE")
	No_Halo_Msg:SetText('You currently do not know Halo. |n|nPlease select the Halo talent to use HaloPro|r')
	--HP_Unlocked_Msg:SetText('|cff00ddaashift + mousewheel to scale bar|nalt + mousewheel to change buttons padding|nmousewheel to change columns|r')
	No_Halo_Msg:SetPoint('CENTER',0,0)
	No_Halo_Msg:Hide()
		
	-- Create the Lock Button
	Lock_Button = "Lock HaloPro"
	template = "UICheckButtonTemplate"
	Lock_checkButton = CreateFrame("CheckButton",Lock_Button,panel,template) --frameType, frameName, frameParent, frameTemplate    
	Lock_checkButton:SetPoint("TopLeft",10,-10)
	Lock_checkButton.text = _G[Lock_Button.."Text"]
	
	if Lock_Flag == 0 then
		Lock_checkButton:SetChecked(false)
		Lock_checkButton.text:SetText("HaloPro is Unlocked - Check to lock")
		HP_Lock()
	elseif Lock_Flag == 1 then
		Lock_checkButton:SetChecked(true)
		Lock_checkButton.text:SetText("HaloPro is Locked")
		HP_Lock()
	end
	isLock_checkButton = Lock_checkButton:GetChecked()
	if isLock_checkButton == nill then
		Lock_Flag = 0
		HP_Lock()
	else
		Lock_Flag = 1
		HP_Lock()
	end
	
	-- Create Warn when off cooldown button
	OffCD_Warn_Button = "Flash when off cooldown"
	template = "UICheckButtonTemplate"
	OffCD_Flash_checkButton = CreateFrame("CheckButton",OffCD_Warn_Button,panel,template) --frameType, frameName, frameParent, frameTemplate    
	OffCD_Flash_checkButton:SetPoint("TopLeft",10,-60)
	OffCD_Flash_checkButton.text = _G[OffCD_Warn_Button.."Text"]
	isOffCD_Flash_checkButton = OffCD_Flash_checkButton:GetChecked();
		if isOffCD_Flash_checkButton == nill then
			OffCD_Flag = 0
			OffCD_Flash_checkButton:SetChecked(false)
			OffCD_Flash_checkButton.text:SetText("Will NOT warn when Halo is off cooldown |n  - Check to enable warning")
		else
			OffCD_Flag = 1
			OffCD_Flash_checkButton:SetChecked(true)
			OffCD_Flash_checkButton.text:SetText("WILL warn when Halo is off cooldown")
		end
		
	-- Create sub panel to hold width and height sliders / editboxes
	HP_Options_Sub_Panel = CreateFrame("MessageFrame", "Width_Sub_Panel", panel)
	HP_Options_Sub_Panel:SetPoint("TopLeft",80, -100)
	HP_Options_Sub_Panel:SetWidth(1200)
	HP_Options_Sub_Panel:SetHeight(100)
	HP_Options_Sub_Panel:Show()
	XY_Relative_Pos()
	HPSound()
	
	-- Create Button to jump to Theme panel
	Theme_Panel_Shortcut = "Change Theme"
	template = "UIPanelButtonTemplate"
	Theme_Button = CreateFrame("Button",Theme_Panel_Shortcut,HP_Options_Sub_Panel,template)
	Theme_Button:SetPoint("Bottom",-605,-355)
	Theme_Button:SetWidth(120)
	Theme_Button:SetText("Change Theme")
	
	-- Create Button to toggle tracking target
	HP_Tracking_Switch = "Change Theme"
	template = "UIPanelButtonTemplate"
	HP_Track_Toggle = CreateFrame("Button",HP_Tracking_Switch,HP_Options_Sub_Panel,template)
	HP_Track_Toggle:SetPoint("Bottom",-130,-355)
	HP_Track_Toggle:SetWidth(120)
	HP_Track_Toggle:SetText("Track: "..HP_Tracking)
	if HP_Tracking == 'focus' then
		HP_Track_Toggle:SetButtonState("PUSHED")
	elseif HP_Tracking == 'target' then
		HP_Track_Toggle:SetButtonState("NORMAL")
	end
		
	-- Create Sound Enable button
	Sound_Warn_Button = "Enable Sound Warning"
	template = "UICheckButtonTemplate"
	Sound_checkButton = CreateFrame("CheckButton",Sound_Warn_Button,HP_Options_Sub_Panel,template) --frameType, frameName, frameParent, frameTemplate    
	Sound_checkButton:SetPoint("Center",-405,75)
	Sound_checkButton.text = _G[Sound_Warn_Button.."Text"]
	isSound_checkButton = Sound_checkButton:GetChecked();
	if isSound_checkButton == nil then
		HP_Sound_Flag = 0
		Sound_checkButton:SetChecked(false)
		Sound_checkButton.text:SetText("Sound warning disabled |n  - Check to enable sound warning")
	else
		HP_Sound_Flag = 1
		Sound_checkButton:SetChecked(true)
		Sound_checkButton.text:SetText("WILL play sound warning |n  when in proper Halo range")
	end
	
	-- Create Editbox to set HaloPro width
	Set_HP_Width = CreateFrame("EditBox", "Edit_Box_Width", HP_Options_Sub_Panel, "InputBoxTemplate")
	Set_HP_Width:SetWidth(70)
	Set_HP_Width:SetHeight(20)
	Set_HP_Width:SetPoint("Left",40, -20)
	Set_HP_Width:SetAutoFocus(false)
	Set_HP_Width:EnableKeyboard(true)
	Set_HP_Width:SetFontObject("GameFontHighlight")
	Set_HP_Width:SetJustifyH("Center")
	Set_HP_Width:SetJustifyV("Center")
	Set_HP_Width:SetTextInsets(0, 5, 0, 0)
	Set_HP_Width:SetNumeric(true)
	Set_HP_Width:SetNumber(HP_width)
	Set_HP_Width:Hide()
	
	-- Create Editbox to set HaloPro height
	Set_HP_Height = CreateFrame("EditBox", "Edit_Box_Height", HP_Options_Sub_Panel, "InputBoxTemplate")
	Set_HP_Height:SetWidth(70)
	Set_HP_Height:SetHeight(20)
	Set_HP_Height:SetPoint("Left",350, -20)
	Set_HP_Height:SetAutoFocus(false)
	Set_HP_Height:EnableKeyboard(true)
	Set_HP_Height:SetFontObject("GameFontHighlight")
	Set_HP_Height:SetJustifyH("Center")
	Set_HP_Height:SetJustifyV("Center")
	Set_HP_Height:SetTextInsets(0, 5, 0, 0)
	Set_HP_Height:SetNumeric(true)
	Set_HP_Height:SetNumber(HP_height)
	Set_HP_Height:Hide()
	
	-- Create Editbox to set HaloPro X position
	Set_HP_X_Pos = CreateFrame("EditBox", "Edit_Box_X", HP_Options_Sub_Panel, "InputBoxTemplate")
	Set_HP_X_Pos:SetWidth(70)
	Set_HP_X_Pos:SetHeight(20)
	Set_HP_X_Pos:SetPoint("Left",40, -125)
	Set_HP_X_Pos:SetAutoFocus(false)
	Set_HP_X_Pos:EnableKeyboard(true)
	Set_HP_X_Pos:SetFontObject("GameFontHighlight")
	Set_HP_X_Pos:SetJustifyH("Center")
	Set_HP_X_Pos:SetJustifyV("Center")
	Set_HP_X_Pos:SetTextInsets(0, 5, 0, 0)
	Set_HP_X_Pos:SetText(0)
	Set_HP_X_Pos:Hide()
	
	-- Create Editbox to set HaloPro X position
	Set_HP_Y_Pos = CreateFrame("EditBox", "Edit_Box_Y", HP_Options_Sub_Panel, "InputBoxTemplate")
	Set_HP_Y_Pos:SetWidth(70)
	Set_HP_Y_Pos:SetHeight(20)
	Set_HP_Y_Pos:SetPoint("Left",350, -125)
	Set_HP_Y_Pos:SetAutoFocus(false)
	Set_HP_Y_Pos:EnableKeyboard(true)
	Set_HP_Y_Pos:SetFontObject("GameFontHighlight")
	Set_HP_Y_Pos:SetJustifyH("Center")
	Set_HP_Y_Pos:SetJustifyV("Center")
	Set_HP_Y_Pos:SetTextInsets(0, 5, 0, 0)
	Set_HP_Y_Pos:SetText(0)
	Set_HP_Y_Pos:Hide()	
	
	-- Create width slider
	HP_Width_Slider = "Adjust the width of HaloPro"
	WidthSlider = CreateFrame("Slider", "HP_Width_Slider", HP_Options_Sub_Panel, "OptionsSliderTemplate")
	WidthSlider:SetWidth(250)
	WidthSlider:SetHeight(15)
	WidthSlider:SetOrientation('Horizontal')
	WidthSlider:SetPoint("Left",-52,-02)
	WidthSlider.text = _G[HP_Width_Slider.."Text"]
	WidthSlider:SetMinMaxValues(10,1000)
	WidthSlider:SetValue(HP_width)
	WidthSlider:SetValueStep(10)
		
	WidthSlider.tooltipText = 'Adjust the width of HaloPro (While HaloPro is unlocked, you can place your cursor over the HaloPro bar, and mouse wheel scroll, to adjust width)'   -- Creates a tooltip on mouseover.
	_G[WidthSlider:GetName() .. 'Low']:SetText('shorter')    -- Sets the left-side slider text (default is "Low").
	_G[WidthSlider:GetName() .. 'High']:SetText('wider')     -- Sets the right-side slider text (default is "High").
	_G[WidthSlider:GetName() .. 'Text']:SetText('Width')     -- Sets the "title" text (top-centre of slider).
	
	-- Create height slider
	HP_Height_Slider = "Adjust the height of HaloPro"
	HeightSlider = CreateFrame("Slider", "HP_Height_Slider", HP_Options_Sub_Panel, "OptionsSliderTemplate")
	HeightSlider:SetWidth(250)
	HeightSlider:SetHeight(15)
	HeightSlider:SetOrientation('Horizontal')
	HeightSlider:SetPoint("Left",258,-02)
	HeightSlider.text = _G[HP_Width_Slider.."Text"]
	HeightSlider:SetMinMaxValues(1,100)
	HeightSlider:SetValue(HP_height)
	HeightSlider:SetValueStep(1)
	
	HeightSlider.tooltipText = 'Adjust the height of HaloPro (While HaloPro is unlocked, you can place your cursor over the HaloPro bar, and SHIFT + mouse wheel scroll, to adjust height)'   -- Creates a tooltip on mouseover.
	_G[HeightSlider:GetName() .. 'Low']:SetText('thinner')     -- Sets the left-side slider text (default is "Low").
	_G[HeightSlider:GetName() .. 'High']:SetText('thicker')    -- Sets the right-side slider text (default is "High").
	_G[HeightSlider:GetName() .. 'Text']:SetText('Height')     -- Sets the "title" text (top-centre of slider).
	
	-- Create X position slider
	HP_Xpos_Slider = "Adjust the X Position of HaloPro"
	XposSlider = CreateFrame("Slider", "HP_Xpos_Slider", HP_Options_Sub_Panel, "OptionsSliderTemplate")
	XposSlider:SetWidth(250)
	XposSlider:SetHeight(15)
	XposSlider:SetOrientation('Horizontal')
	XposSlider:SetPoint("Left",-52,-107)
	XposSlider.text = _G[HP_Xpos_Slider.."Text"]
	XposSlider:SetMinMaxValues(-2000,2000)
	XposSlider:SetValue(xOfs)
	XposSlider:SetValueStep(1)
		
	XposSlider.tooltipText = 'Adjust the X position of HaloPro (While HaloPro is unlocked, you can left click on the HaloPro bar and drag to reposition)'   -- Creates a tooltip on mouseover.
	_G[XposSlider:GetName() .. 'Low']:SetText('left')        	-- Sets the left-side slider text (default is "Low").
	_G[XposSlider:GetName() .. 'High']:SetText('right')     	-- Sets the right-side slider text (default is "High").
	_G[XposSlider:GetName() .. 'Text']:SetText('X Position')    -- Sets the "title" text (top-centre of slider).
	
	-- Create Y postion slider
	HP_Ypos_Slider = "Adjust the Y Position of HaloPro"
	YposSlider = CreateFrame("Slider", "HP_Ypos_Slider", HP_Options_Sub_Panel, "OptionsSliderTemplate")
	YposSlider:SetWidth(250)
	YposSlider:SetHeight(15)
	YposSlider:SetOrientation('Horizontal')
	YposSlider:SetPoint("Left",258,-107)
	YposSlider.text = _G[HP_Ypos_Slider.."Text"]
	YposSlider:SetMinMaxValues(-2000,2000)
	YposSlider:SetValue(yOfs)
	YposSlider:SetValueStep(1)
	
	YposSlider.tooltipText = 'Adjust the Y position of HaloPro (While HaloPro is unlocked, you can left click on the HaloPro bar and drag to reposition)'   -- Creates a tooltip on mouseover.
	_G[YposSlider:GetName() .. 'Low']:SetText('lower')        	-- Sets the left-side slider text (default is "Low").
	_G[YposSlider:GetName() .. 'High']:SetText('higher')     	-- Sets the right-side slider text (default is "High").
	_G[YposSlider:GetName() .. 'Text']:SetText('Y position')   	-- Sets the "title" text (top-centre of slider).
		
	-- Create Max Alpha slider
	Max_Alpha_Slider = "Adjust the max alpha of HaloPro"
	MaxASlider = CreateFrame("Slider", "Max_Alpha_Slider", panel, "OptionsSliderTemplate")
	MaxASlider:SetWidth(306)
	MaxASlider:SetHeight(20)
	MaxASlider:SetOrientation('Horizontal')
	MaxASlider:SetPoint("Center",0,-50)
	MaxASlider.text = _G[Max_Alpha_Slider.."Text"]
	MaxASlider:SetMinMaxValues(0.1,0.9)
	MaxASlider:SetValue(max_alpha_adjust)
	MaxASlider:SetValueStep(0.025)
		
	MaxASlider.tooltipText = 'Adjust the Max alpha of HaloPro (lower# means more transparent)'   -- Creates a tooltip on mouseover.
	_G[MaxASlider:GetName() .. 'Low']:SetText('0.1')        	-- Sets the left-side slider text (default is "Low").
	_G[MaxASlider:GetName() .. 'High']:SetText('0.9')     		-- Sets the right-side slider text (default is "High").
	_G[MaxASlider:GetName() .. 'Text']:SetText('Max Alpha: ' .. max_alpha_adjust)       -- Sets the "title" text (top-centre of slider).
	
	-- Create Fade In Timer Slider
	Fade_IN_Slider = "Adjust how many seconds before Halo is off cooldown, should HaloPro start to fade in"
	FadeINSlider = CreateFrame("Slider", "Fade_IN_Slider", panel, "OptionsSliderTemplate")
	FadeINSlider:SetWidth(306)
	FadeINSlider:SetHeight(20)
	FadeINSlider:SetOrientation('Horizontal')
	FadeINSlider:SetPoint("Center",0,-100)
	FadeINSlider.text = _G[Fade_IN_Slider.."Text"]
	FadeINSlider:SetMinMaxValues(0,40)
	FadeINSlider:SetValue(fadeintimer)
	FadeINSlider:SetValueStep(1)
	
	FadeINSlider.tooltipText = 'Set how many seconds left on the cooldown of Halo, should HaloPro begin to fade back in'   -- Creates a tooltip on mouseover.
	_G[FadeINSlider:GetName() .. 'Low']:SetText('0')        	-- Sets the left-side slider text (default is "Low").
	_G[FadeINSlider:GetName() .. 'High']:SetText('40')     		-- Sets the right-side slider text (default is "High").
	_G[FadeINSlider:GetName() .. 'Text']:SetText('Begin fade in at: ' .. fadeintimer .. " secs")       -- Sets the "title" text (top-centre of slider).
	
	-- Create Number of Off Cooldown Flashes Slider
	Flash_Num_Slider = "Adjust how many times HaloPro should flash when it comes off cooldown"
	FlashNumSlider = CreateFrame("Slider", "Flash_Num_Slider", panel, "OptionsSliderTemplate")
	FlashNumSlider:SetWidth(306)
	FlashNumSlider:SetHeight(20)
	FlashNumSlider:SetOrientation('Horizontal')
	FlashNumSlider:SetPoint("Center",0,-150)
	FlashNumSlider.text = _G[Flash_Num_Slider.."Text"]
	FlashNumSlider:SetMinMaxValues(1,5)
	FlashNumSlider:SetValue(flash_num)
	FlashNumSlider:SetValueStep(1)
	
	FlashNumSlider.tooltipText = 'Set how many seconds left on the cooldown of Halo, should HaloPro begin to fade back in'   -- Creates a tooltip on mouseover.
	_G[FlashNumSlider:GetName() .. 'Low']:SetText('1')        	-- Sets the left-side slider text (default is "Low").
	_G[FlashNumSlider:GetName() .. 'High']:SetText('5')     	-- Sets the right-side slider text (default is "High").
	_G[FlashNumSlider:GetName() .. 'Text']:SetText('# flashes when off cooldown: ' .. flash_num .. " flashes")       -- Sets the "title" text (top-centre of slider).
	
	-- Create Flash speed Slider
	Flash_Speed_Slider = "Adjust how fast HaloPro should flash when it comes off cooldown"
	FlashSpeedSlider = CreateFrame("Slider", "Flash_Speed_Slider", panel, "OptionsSliderTemplate")
	FlashSpeedSlider:SetWidth(306)
	FlashSpeedSlider:SetHeight(20)
	FlashSpeedSlider:SetOrientation('Horizontal')
	FlashSpeedSlider:SetPoint("Center",0,-200)
	FlashSpeedSlider.text = _G[Flash_Speed_Slider.."Text"]
	FlashSpeedSlider:SetMinMaxValues(1,5)
	FlashSpeedSlider:SetValue(tcount_time1)
	FlashSpeedSlider:SetValueStep(1)
	
	FlashSpeedSlider.tooltipText = 'Set how fast HaloPro should flash when Halo is off cooldown'   -- Creates a tooltip on mouseover.
	_G[FlashSpeedSlider:GetName() .. 'Low']:SetText('Fast')       	-- Sets the left-side slider text (default is "Low").
	_G[FlashSpeedSlider:GetName() .. 'High']:SetText('Slow')     	-- Sets the right-side slider text (default is "High").
	_G[FlashSpeedSlider:GetName() .. 'Text']:SetText('Speed of flashes when off cooldown: ')       -- Sets the "title" text (top-centre of slider).
		
	UnLocked_HP_Panel()
	-- OnClick Handler Lock HP	
	Lock_checkButton:SetScript("OnClick", function(self)
		isLock_checkButton = self:GetChecked();
		if isLock_checkButton == nill then
			if HaloCheck_Flag == 1 then
				options_open_Flag = 1
				f:Show()
			end
			Lock_checkButton.text:SetText("HaloPro is Unlocked - Check to lock")
			Lock_Flag = 0
			OffCD_Flash_checkButton:Show()
			if OffCD_Flag == 1 then
				FlashNumSlider:Show()
				FlashSpeedSlider:Show()
			end
			HP_Options_Sub_Panel:Show()
			HP_Sub_Panel_Refresh(HP_Options_Sub_Panel)
			MaxASlider:Show()
			FadeINSlider:Show()
			HP_Lock()
			if options_open_Flag == 1 then
					HP_Unlocked_Msg:Hide()
			end
		else
			if HaloCheck_Flag == 1 then
				options_open_Flag = 0
				f:Hide()
			end
			Lock_checkButton.text:SetText("HaloPro is Locked")
			Lock_Flag = 1
			OffCD_Flash_checkButton:Hide()
			HP_Options_Sub_Panel:Hide()
			MaxASlider:Hide()
			FadeINSlider:Hide()
			FlashNumSlider:Hide()
			FlashSpeedSlider:Hide()
			HP_Lock()
			if options_open_Flag == 1 then
					HP_Unlocked_Msg:Hide()
			end
		end
		
	end)
	
	-- Set up size boxes on load
	HP_Options_Sub_Panel:SetScript("OnLoad", function(self)
		local height_entered = Set_HP_Height:GetNumber()
		HP_height = height_entered
		HP_Resize_height(UIParent)
		local width_entered = Set_HP_Width:GetNumber()
		HP_width = width_entered
		HP_Resize_width(UIParent)
	end)
			
	-- Various Handlers to save the changed width
	Set_HP_Width:SetScript("OnEditFocusLost", function(self)
		local width_entered = Set_HP_Width:GetNumber()
		HP_width = width_entered
		HP_Resize_width(UIParent)
	end)
	Set_HP_Width:SetScript("OnEnterPressed", function(self)
		local width_entered = Set_HP_Width:GetNumber()
		HP_width = width_entered
		HP_Resize_width(UIParent)
	end)
	Set_HP_Width:SetScript("OnTabPressed", function(self)
		local width_entered = Set_HP_Width:GetNumber()
		HP_width = width_entered
		HP_Resize_width(UIParent)
	end)
	
	-- Various Handlers to save the changed height
	Set_HP_Height:SetScript("OnEditFocusLost", function(self)
		local height_entered = Set_HP_Height:GetNumber()
		HP_height = height_entered
		HP_Resize_height(UIParent)
	end)
	Set_HP_Height:SetScript("OnEnterPressed", function(self)
		local height_entered = Set_HP_Height:GetNumber()
		HP_height = height_entered
		HP_Resize_height(UIParent)
	end)
	Set_HP_Height:SetScript("OnTabPressed", function(self)
		local height_entered = Set_HP_Height:GetNumber()
		HP_height = height_entered
		HP_Resize_height(UIParent)
	end)
	
	-- OnValueChanged Handler Width
	WidthSlider:SetScript("OnValueChanged", function(self, event)
		HP_width = event
		HP_Resize_width()       
	end)
	-- OnValueChanged Handler Height
	HeightSlider:SetScript("OnValueChanged", function(self, event)
		HP_height = event
		HP_Resize_height()       
	end)
	-- OnValueChanged Handler X position
	XposSlider:SetScript("OnValueChanged", function(self, event)
		xOfs = event
		HP_Set_Position()       
	end)
	-- OnValueChanged Handler Y position
	YposSlider:SetScript("OnValueChanged", function(self, event)
		yOfs = event
		HP_Set_Position()       
	end)
	-- Various Handlers to change X position
	Set_HP_X_Pos:SetScript("OnEditFocusLost", function(self)
		local X_Pos_entered = Set_HP_X_Pos:GetNumber()
		xOfs = X_Pos_entered
		Set_HP_X_Pos:ClearFocus()
		HP_Set_Position()
	end)
	Set_HP_X_Pos:SetScript("OnEnterPressed", function(self)
		local X_Pos_entered = Set_HP_X_Pos:GetNumber()
		xOfs = X_Pos_entered
		Set_HP_X_Pos:ClearFocus()
		HP_Set_Position()
	end)
	Set_HP_X_Pos:SetScript("OnTabPressed", function(self)
		local X_Pos_entered = Set_HP_X_Pos:GetNumber()
		xOfs = X_Pos_entered
		Set_HP_X_Pos:ClearFocus()
		HP_Set_Position()
	end)
	
	-- Various Handlers to change Y position
	Set_HP_Y_Pos:SetScript("OnEditFocusLost", function(self)
		local Y_Pos_entered = Set_HP_Y_Pos:GetNumber()
		yOfs = Y_Pos_entered
		Set_HP_Y_Pos:ClearFocus()
		HP_Set_Position()
	end)
	Set_HP_Y_Pos:SetScript("OnEnterPressed", function(self)
		local Y_Pos_entered = Set_HP_Y_Pos:GetNumber()
		yOfs = Y_Pos_entered
		Set_HP_Y_Pos:ClearFocus()
		HP_Set_Position()
	end)
	Set_HP_Y_Pos:SetScript("OnTabPressed", function(self)
		local Y_Pos_entered = Set_HP_Y_Pos:GetNumber()
		yOfs = Y_Pos_entered
		Set_HP_Y_Pos:ClearFocus()
		HP_Set_Position()
	end)
	
	-- OnValueChanged Handler Alpha HP
	MaxASlider:SetScript("OnValueChanged", function(self, event)
		event = math.floor( (event * 10^3) + 0.5) / (10^3)
		max_alpha_adjust = event
		_G[MaxASlider:GetName() .. 'Text']:SetText('Alpha: ' .. max_alpha_adjust)       -- Sets the "title" text (top-centre of slider).
	end)

	-- OnValueChanged Handler Fade In HP
	FadeINSlider:SetScript("OnValueChanged", function(self, event)
		fadeintimer = event
		_G[FadeINSlider:GetName() .. 'Text']:SetText('Begin fade in at: ' .. fadeintimer .. " secs")       -- Sets the "title" text (top-centre of slider).
	end)
	
	-- OnValueChanged Handler Numer of Flashes
	FlashNumSlider:SetScript("OnValueChanged", function(self, event)
		flash_num = event
		_G[FlashNumSlider:GetName() .. 'Text']:SetText('# flashes when off cooldown: ' .. flash_num .. " flashes")       -- Sets the "title" text (top-centre of slider).
	end)
	
	-- OnValueChanged Handler Speed of Flashes
	FlashSpeedSlider:SetScript("OnValueChanged", function(self, event)
		tcount_time1 = event
	end)
	Theme_Button:SetScript("OnClick", function(self)
		InterfaceOptionsFrame_OpenToCategory(HP_Options_Theme)	
	end)
	HP_Track_Toggle:SetScript("OnClick", function(self)
		if HP_Tracking == 'focus' then
			HP_Tracking = 'target'
			HP_Track_Toggle:UnlockHighlight()
			HP_Track_Toggle:SetText("Track: "..HP_Tracking)
			print("HaloPro is now tracking: Your Current Target")
		elseif HP_Tracking == 'target' then
			HP_Tracking = 'focus'
			HP_Track_Toggle:LockHighlight()
			HP_Track_Toggle:SetText("Track: "..HP_Tracking)
			print("HaloPro is now tracking: Your Focus Target")
		end
	end)
		
	HaloPro_CreateOptionsPanelTheme(HP_Options_Theme)
	
	--[[ This will remove unwanted frames, just set the frame name in quotes
	frameName = "General"
	RemoveInterfaceOptions(frameName)]]
	
end
function HaloPro_CreateOptionsPanelTheme(HP_Options_Theme)

	-- Create Current Talent Notification
	Current_Talents_Msg = CreateFrame('frame', 'HP_Talents_Msg', HP_Options_Theme)
	Current_Talents_Msg:SetAllPoints()
	Current_Talents_Msg = Current_Talents_Msg:CreateFontString(nil, 'OVERLAY')
	Current_Talents_Msg:SetFont(STANDARD_TEXT_FONT, 18, "OUTLINE")
	Current_Talents_Msg:SetPoint('CENTER',0,200)
	Current_Talents_Msg:SetText('Currently, you are using '..HP_activeSpec)
	
	-- Create Current Specialization Notification
	Current_Special_Msg = CreateFrame('frame', 'HP_Special_Msg', HP_Options_Theme)
	Current_Special_Msg:SetAllPoints()
	Current_Special_Msg = Current_Special_Msg:CreateFontString(nil, 'OVERLAY')
	Current_Special_Msg:SetFont(STANDARD_TEXT_FONT, 18, "OUTLINE")
	Current_Special_Msg:SetPoint('CENTER',0,-175)
	Current_Special_Msg:SetText(HP_activeSpecial)

	-- Create Spec 1 Theme Slider
	Spec1_Theme_Slider = "Set the theme of HaloPro when in Spec 1"
	Spec1_T_Slider = CreateFrame("Slider", "Spec1_Theme_Slider", HP_Options_Theme, "OptionsSliderTemplate")
	Spec1_T_Slider:SetWidth(306)
	Spec1_T_Slider:SetHeight(20)
	Spec1_T_Slider:SetOrientation('Horizontal')
	Spec1_T_Slider:SetPoint("Center",0,100)
	Spec1_T_Slider.text = _G[Spec1_Theme_Slider.."Text"]
	Spec1_T_Slider:SetMinMaxValues(1,5)
	Spec1_T_Slider:SetValue(Theme_Index_Spec1)
	Spec1_T_Slider:SetValueStep(1)
		
	Spec1_T_Slider.tooltipText = 'Change the theme of HaloPro for your Primary Spec'   -- Creates a tooltip on mouseover.
	_G[Spec1_T_Slider:GetName() .. 'Low']:SetText('1')        	-- Sets the left-side slider text (default is "Low").
	_G[Spec1_T_Slider:GetName() .. 'High']:SetText('5')     	-- Sets the right-side slider text (default is "High").
	_G[Spec1_T_Slider:GetName() .. 'Text']:SetText('Theme for Primary Spec: ' .. Theme_select_Spec1)       -- Sets the "title" text (top-centre of slider).

	-- Create preview frame for Main Spec
	Spec_1_Preview = CreateFrame("Frame","Spec_1_Preview",HP_Options_Theme)
	Spec_1_Preview:SetWidth(500)
	Spec_1_Preview:SetHeight(18)
	Spec_1_Preview:SetPoint("Center",0,70)
	Spec1_t = Spec_1_Preview:CreateTexture(Spec_1_t_init,"BACKGROUND")
	
	-- Create Spec 2 Theme Slider
	Spec2_Theme_Slider = "Set the theme of HaloPro when in Spec 2"
	Spec2_T_Slider = CreateFrame("Slider", "Spec2_Theme_Slider", HP_Options_Theme, "OptionsSliderTemplate")
	Spec2_T_Slider:SetWidth(306)
	Spec2_T_Slider:SetHeight(20)
	Spec2_T_Slider:SetOrientation('Horizontal')
	Spec2_T_Slider:SetPoint("Center",0,-30)
	Spec2_T_Slider.text = _G[Spec2_Theme_Slider.."Text"]
	Spec2_T_Slider:SetMinMaxValues(1,5)
	Spec2_T_Slider:SetValue(Theme_Index_Spec2)
	Spec2_T_Slider:SetValueStep(1)
		
	Spec2_T_Slider.tooltipText = 'Change the theme of HaloPro for your Secondary Spec'   -- Creates a tooltip on mouseover.
	_G[Spec2_T_Slider:GetName() .. 'Low']:SetText('1')        	-- Sets the left-side slider text (default is "Low").
	_G[Spec2_T_Slider:GetName() .. 'High']:SetText('5')     	-- Sets the right-side slider text (default is "High").
	_G[Spec2_T_Slider:GetName() .. 'Text']:SetText('Theme for Secondary Spec: ' .. Theme_select_Spec2)       -- Sets the "title" text (top-centre of slider).

	-- Create preview frame for Secondary Spec
	Spec_2_Preview = CreateFrame("Frame","Spec_2_Preview",HP_Options_Theme)
	Spec_2_Preview:SetWidth(500)
	Spec_2_Preview:SetHeight(18)
	Spec_2_Preview:SetPoint("Center",0,-60)
	Spec2_t = Spec_2_Preview:CreateTexture(Spec_2_t_init,"BACKGROUND")
	
	Theme_select_Spec_store()
	local Chosen_Theme = 0
	if HP_currentSpec == 1 then
		Chosen_Theme = Theme_select_Spec1
	elseif HP_currentSpec == 2 then
		Chosen_Theme = Theme_select_Spec2
	else
		Chosen_Theme = default_Theme_select_Spec1
	end
	Spec1_t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec1.."\\center.tga")
	Spec1_t:SetAllPoints(Spec_1_Preview)
	Spec_1_Preview.texture = Spec1_t
	Spec2_t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec2.."\\center.tga")
	Spec2_t:SetAllPoints(Spec_2_Preview)
	Spec_2_Preview.texture = Spec1_2
		
	-- Create Button to jump to Main Options panel
	Main_Panel_Shortcut = "Main Options"
	template = "UIPanelButtonTemplate"
	Main_Options_Button = CreateFrame("Button",Main_Panel_Shortcut,HP_Options_Theme,template)
	Main_Options_Button:SetPoint("BottomLeft",14,14)
	Main_Options_Button:SetWidth(120)
	Main_Options_Button:SetText("Main Options")
	
	-- Handlers for all the options on the Theme panel
	Spec1_T_Slider:SetScript("OnValueChanged", function(self, event)
		Theme_Index_Spec1 = event
		Theme_select_Spec_store()
		if HP_currentSpec == 1 then
			t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec1.."\\center.tga")
		end
		Spec1_t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec1.."\\center.tga")
		_G[Spec1_T_Slider:GetName() .. 'Text']:SetText('Theme for Primary Spec: ' .. Theme_select_Spec1)       -- Sets the "title" text (top-centre of slider).
	end)
	
	Spec2_T_Slider:SetScript("OnValueChanged", function(self, event)
		Theme_Index_Spec2 = event
		Theme_select_Spec_store()
		local Chosen_Theme = 0
		if HP_currentSpec == 2 then
			t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec2.."\\center.tga")
		end
		Spec2_t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec2.."\\center.tga")
		_G[Spec2_T_Slider:GetName() .. 'Text']:SetText('Theme for Secondary Spec: ' .. Theme_select_Spec2)       -- Sets the "title" text (top-centre of slider).
	end)
	
	Main_Options_Button:SetScript("OnClick", function(self)
		InterfaceOptionsFrame_OpenToCategory(HP_Panel_Name_Store)	
	end)	
end
function UnLocked_HP_Panel(panel)
	
	if OffCD_Flag == nil then
		OffCD_Flag = default_OffCD_Flag
	end
	if OffCD_Flag == 0 then
			OffCD_Flash_checkButton:SetChecked(false)
			OffCD_Flash_checkButton.text:SetText("Will NOT warn when Halo is off cooldown |n  - Check to enable warning")
	elseif OffCD_Flag == 1 then
			OffCD_Flash_checkButton:SetChecked(true)
			OffCD_Flash_checkButton.text:SetText("WILL warn when Halo is off cooldown")
	end
		
	if Lock_Flag == 0 then
		OffCD_Flash_checkButton:Show()
		HP_Options_Sub_Panel:Show()
		MaxASlider:Show()
		FadeINSlider:Show()
		if OffCD_Flag == 1 then
			FlashNumSlider:Show()
			FlashSpeedSlider:Show()
		end
		HP_Resize_height()
		HP_Resize_width()
	elseif Lock_Flag == 1 then
		OffCD_Flash_checkButton:Hide()
		HP_Options_Sub_Panel:Hide()
		MaxASlider:Hide()
		FadeINSlider:Hide()
		FlashNumSlider:Hide()
		FlashSpeedSlider:Hide()
		HP_Resize_height()
		HP_Resize_width()
	end
	
	OffCD_Flash_checkButton:SetScript("OnClick", function(self)
		isOffCD_Flash_checkButton = self:GetChecked();
		if isOffCD_Flash_checkButton == nill then
			OffCD_Flag = 0
			OffCD_Flash_checkButton:SetChecked(false)
			OffCD_Flash_checkButton.text:SetText("Will NOT warn when Halo is off cooldown |n  - Check to enable warning")
			FlashNumSlider:Hide()
			FlashSpeedSlider:Hide()
		else
			OffCD_Flag = 1
			OffCD_Flash_checkButton:SetChecked(true)
			OffCD_Flash_checkButton.text:SetText("WILL warn when Halo is off cooldown")
			FlashNumSlider:Show()
			FlashSpeedSlider:Show()
		end
	end)
end

-- Function to remove messed up panel
function RemoveInterfaceOptions(frameName, bParent)
       -- Ensure that the variables passed are valid
       assert(type(frameName) == "string" and (type(bParent) == "boolean" or bParent == nil), 'Syntax: RemoveInterfaceOptions(frameName[, bParent])');
       
       -- Setup local variables
       local removeList = {};
       local nextFreeArraySpace = 1;
       
       -- If the name given is NOT a parent frame
       if not(bParent) then
           -- Add this frame to the list to be deleted
           removeList[frameName] = true;
       end
       
       -- Loop though Bliz's Interface Options Frames looking for the frames to remove
       for i=1, #INTERFACEOPTIONS_ADDONCATEGORIES do
           -- Store this Interface frame
           local v = INTERFACEOPTIONS_ADDONCATEGORIES[i];
           
           -- Check if this is the frame we want to remove or if bParent
           -- the child of the want we want to remove
           -- or just one we want to keep
           if (removeList[v.name] or (bParent and v.parent == frameName)) or (bParent and removeList[v.parent]) then
               -- Wipe this frame from the array by making it 'true'
               removeList[v.name] = true;
           else
               -- We want to keep this frame so move it up the array
               -- to remove any holes caused by the deleted frames
               INTERFACEOPTIONS_ADDONCATEGORIES[nextFreeArraySpace] = INTERFACEOPTIONS_ADDONCATEGORIES[i];
               nextFreeArraySpace = nextFreeArraySpace + 1;
           end;
       end;
       
       -- Loop though all of the interface frames after the last good one removing them
       for i=nextFreeArraySpace, #INTERFACEOPTIONS_ADDONCATEGORIES do
           INTERFACEOPTIONS_ADDONCATEGORIES[i] = nil;
       end;
       
       -- Tell Bliz's interface frame to update now to reflect the removed frames
       InterfaceAddOnsList_Update();
   end

function HP_Lock()
	
	if Lock_Flag == nil then
		Lock_Flag = default_Lock_Flag
	end
	if Lock_Flag == 0 then
		HP_Unlocked_Msg:Show()
		f:EnableMouse(true)
		f:EnableKeyboard(true)
		f:EnableMouseWheel(true)
	elseif Lock_Flag == 1 then
		HP_Unlocked_Msg:Hide()
		f:EnableMouse(false)
		f:EnableKeyboard(false)
		f:EnableMouseWheel(false)
	end
end   

function HP_Max_Alpha()
f:SetMovable(true)
	f:SetResizable(true)
	f:EnableMouse(true)
	f:EnableKeyboard(true)
	f:EnableMouseWheel(true)
	if max_alpha_adjust == nil then
		max_alpha_adjust = HP_FadeIN
	end
	max_alpha_adjust = max_alpha_adjust - max_alpha_adjust + maa_amount
	if max_alpha_adjust > 0.9 then
		max_alpha_adjust = 0.9
	end
	f:SetAlpha(max_alpha_adjust)
	f:EnableMouse(false)
	f:EnableKeyboard(false)
	f:EnableMouseWheel(false)
end

function Default_HP_Settings()
	Lock_Flag = default_Lock_Flag
	f:SetMovable(true)
	f:SetResizable(true)
	f:EnableMouse(true)
	f:EnableKeyboard(true)
	f:EnableMouseWheel(true)
	f:ClearAllPoints()
	HP_height = default_height
	HP_width = default_width
	HP_Sound = default_HP_Sound
	HP_Sound_Flag = default_HP_Sound_Flag 
	f:SetHeight(HP_height) 	
	f:SetWidth(HP_width) 	
	Theme_select_Spec_store()
	Theme_Index_Spec1 = default_Theme_Index_Spec1
	Theme_Index_Spec2 = default_Theme_Index_Spec2
	Theme_select_Spec_store()
	if HP_currentSpec == 1 then
		t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec1.."\\center.tga")
	elseif HP_currentSpec == 2 then
		t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec2.."\\center.tga")
	else
		t:SetTexture("Interface\\AddOns\\HaloPro\\HaloPro_Art\\"..Theme_select_Spec1.."\\center.tga")
	end
	t:SetAllPoints(f)
	f.texture = t
	f:SetPoint("CENTER",0,0)
	f:Show()
	OffCD_Flag = default_off_cd_warning
	fadeintimer = default_fadeintimer
	tcount_time1 = default_tcount_time1 
	flash_num = default_flash_num
	max_alpha_adjust = default_max_alpha_adjust
	f:SetAlpha(max_alpha_adjust)
	print(" ")
	print("-----------------------------------------------------------")
	print(" ")
	print(" HaloPro been reset to its default settings")
	print(" ")
	print("-----------------------------------------------------------")
end
 
function Halo_Check()
	Spell_Type, spell_ID = GetSpellBookItemInfo(SpellToMonitor)
    if spell_ID == 120696 or spell_ID == 120692 or spell_ID == 120517 then  -- Halo had several spellid's throughout beta, so this should cover them all
		HaloCheck_Flag = 1
	elseif spell_ID == nil then
		HaloCheck_Flag = 0
	elseif spell_ID == 8092 then  -- in here for testing purposes when halo is not available, uses Mind Blast instead
		HaloCheck_Flag = 1
	end
end
 
 -- Slash command setup 
SLASH_HaloPro1, SLASH_HaloPro2 = '/hp', '/halopro'; 
function SlashCmdList.HaloPro(msg, editbox)
	local command, rest = msg:match("^(%S*)%s*(.-)$")
	if command == "fade" and #rest >=0 then
		if fadeintimer == nil then
			fadeintimer = default_fadeintimer
		end
		fadeintimer = fadeintimer - fadeintimer + rest
		print(" ")
		print("-----------------------------------------------------------")
		print(" ")
		print(" HaloPro will now start to fade in with " .. fadeintimer .. "secs remaining on the cd")
		print(" ")
		print("-----------------------------------------------------------")
		print(" ")
	elseif command == "maxalpha" and #rest >=0 then
		maa_amount = rest
		HP_Max_Alpha()
		print(" ")
		print("-----------------------------------------------------------")
		print(" ")
		print(" HaloPro alpha is now maxed at " .. max_alpha_adjust)
		print(" ")
		print("-----------------------------------------------------------")
		print(" ")
	elseif command == "offcd" and rest == "yes" then
		OffCD_Flag = 1
		print(" ")
		print("Halo cooldown warning: Enabled!")
		print(" ")
	elseif command == "offcd" and rest == "no" then
		OffCD_Flag = 0
		print(" ")
		print("Halo cooldown warning: Disabled!")
		print(" ")
	elseif command == "sound" and rest == "no" then
		HP_Sound_Flag = 0
		print(" ")
		print("HaloPro's sound warning is now disabled")
		print(" ")
		HP_Sound_Refresh(HP_Options_Sub_Panel)
	elseif command == "sound" and rest == "yes" then
		HP_Sound_Flag = 1
		print(" ")
		print("HaloPro's sound warning is now enabled")
		print(" ")
		HP_Sound_Refresh(HP_Options_Sub_Panel)
	elseif command == "track" and rest == "target" then
		HP_Tracking = 'target'
		print(" ")
		print("HaloPro will now track your current target")
		print(" ")
	elseif command == "track" and rest == "focus" then
		HP_Tracking = 'focus'
		print(" ")
		print("HaloPro will now track your focus target")
		print(" ")
	else
		if msg == 'default'	then
			Default_HP_Settings()
		elseif msg == 'lock' then
			Lock_Flag = 1
			HP_Lock(UIParent)
			print(" ")
			print("-----------------------------------------------------------")
			print(" ")
			print(" HaloPro is now locked and can not be moved or resized")
			print(" ")
			print(" To unlock again use /hp unlock, or /halopro unlock")
			print(" ")
			print(" /hp default returns to default size and center of screen")
			print(" ")
			print("-----------------------------------------------------------")
			print(" ")
		elseif msg == 'unlock' then
			Lock_Flag = 0
			HP_Unlocked_Msg:Show()
			f:SetMovable(true)
			f:SetResizable(true)
			f:EnableMouse(true)
			f:EnableKeyboard(true)
			f:EnableMouseWheel(true)
			print(" ")
			print("-----------------------------------------------------------")
			print(" ")
			print(" HaloPro is now unlocked!")
			print(" ")
			print(" Left mouse drag to move")
			print(" ")
			print(" Mouse scroll with pointer on bar to adjust width")
			print(" ")
			print(" Shift + mouse scroll with pointer on bar to adjust height")
			print(" ")
			print("-----------------------------------------------------------")
			print(" ")
		elseif msg == 'options' then
			InterfaceOptionsFrame_OpenToCategory(HP_Panel_Name_Store)	
		elseif msg == 'testmode' then
			if SpellToMonitor == "Halo" then
				print(" ")
				print("HaloPro is now in 'Test Mode' - switching to monitor Mind Blast")
				print(" ")
				SpellToMonitor = "Mind Blast"
			else
				print(" ")
				print("HaloPro's is now in 'Normal Mode' - now monitoring Halo")
				print(" ")
				SpellToMonitor = "Halo"
			end
		else
			print(" ")
			print("-----------------------------------------------------------")
			print(" ")
			print("/hp or /halopro options...")
			print(" ")
			print(" 'options' - bring up the HaloPro Options gui")
			print(" 'default' - unlocks and resets bar position and size")
			print(" 'lock' - locks down to the bar so it can't be moved or resized")
			print(" 'unlock' - unlocks the bar so it can be moved or resized")
			print(" 'maxalpha #alpha(0.0 - 1.0)' - sets the max alpha of the bar")
			print(" 'fade #secs' - sets how many seconds left on the Halo cd to start fading back in")
			print(" 'offcd yes/no' - should the bar flash when Halo comes off cooldown?")
			print(" 'sound yes/no' - should HaloPro play a sound when at the correct distance for max damage?")
			print(" 'track target/focus - sets whether HaloPro should track your current target or your focus target")
			print(" ")
			print("-----------------------------------------------------------")
			print(" ")
		end
	end
end	